package model

import "github.com/zeromicro/go-zero/core/stores/mon"

var _ TagsModel = (*customTagsModel)(nil)

type (
	// TagsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customTagsModel.
	TagsModel interface {
		tagsModel
	}

	customTagsModel struct {
		*defaultTagsModel
	}
)

// NewTagsModel returns a model for the mongo.
func NewTagsModel(url, db, collection string) TagsModel {
	conn := mon.MustNewModel(url, db, collection)
	return &customTagsModel{
		defaultTagsModel: newDefaultTagsModel(conn),
	}
}
